/********************************************************************
 Mod5282 GPIO example program. This program will demonstrate how
 to use signals GPTA[0.3] and GPTB[0.3] as general purpose I/O
 signals. These signals are brought out to the GPIO header on the
 Mod5282 Carrier Board.
 
 Revision 1.0, 6/10/2003
*********************************************************************/ 
#include "predef.h" 
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <..\..\mod5282\system\sim5282.h>


extern "C" { 
	void UserMain(void * pd);
}

/********************************************************************
 UserMain
 *******************************************************************/
void UserMain(void * pd)
{
	InitializeStack();
	if (EthernetIP==0)GetDHCPAddress(); 
	OSChangePrio(MAIN_PRIO);
	EnableAutoUpdate();

	/* The GPTA and GPTB signals are in two groups of 4 signals each,
	   for a total of 8 GPIO signals. See the 5282 Users Manual, 
	   chapter 20, table 20-23 for detailed information. We are going 
	   to configure the signals as described in the first two lines 
	   of the table.
	*/


	/* Disable timer functions */
	sim.gpt[0].scr1 = 0;
	sim.gpt[1].scr1 = 0;


	/* Configure all signals as outputs. To configure a signal as an
	   input, set the corresponding bit position to a 0 instead of a
	   1. To read the signal value of an input, read the lower 4
	   bits using sim.gpt[0].port, or sim.gpt[1].port. For example,
	   "BYTE value = sim.gpt[0].port & 0x0F"
	*/
	sim.gpt[0].ddr = 0x0F;
	sim.gpt[1].ddr = 0x0F;


	while (1)
	{
		/* Then toggle the ports high and low .... */
		sim.gpt[0].port=0xF; /* GPTA 0..3 high */
		sim.gpt[1].port=0;   /* GPTB 0..3 low */  
	    
		OSTimeDly(5);
		
		sim.gpt[0].port=0;   /* GPTA 0..3 Low */ 
	 	sim.gpt[1].port=0xf; /* GPTB 0..3 high */ 
	    
		OSTimeDly(5);
	}
}
